#include "stm32f10x.h"
#include "Sys.h"

//Przycisk wlaczenia efektow
#define BYPASS   GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_8)

//Obsluga przciskow dla menu
#define BUTTONA GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_4)		
#define BUTTONB  GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_5)	
#define PUSH  GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_6)


void GPIO_Config(void); 
void RCC_Config(void);   
void NVIC_Config(void); 
                                                                                               
void delay(uint32_t us); 
void DMA_Config(void);
void ADC_Config(void);
void DAC_Config(void); 
uint8_t Impulsator(void);
void LCD_value(uint16_t value, uint8_t jednostka);
void Flash_program(void);
void Flash_odczyt(void);
void Flash_zapis(void);
void EXinterrrupt_Init(void);

typedef uint16_t u16;
typedef uint32_t u32;
typedef unsigned char u8;

volatile u32 TIMERUS, buforADC, k, wartoscDELAY, timerPUSH, timerZAPIS, timerzwarcieDAC, timerdioda;
volatile u16 elmdrganBUTTONA;
volatile u8 Shannon, zalDELAYwielokrotny=0, flagaREVERB=0, flagaPUSH, kierunekimp, LEFTRIGHT;
u32 wartoscDAC, delayms, l, delayms2, delayms3, delayms4, 
    l2, l3, l4, delayrev1, 
    delayrev2, wzmocnienieFLANGER=1, wzmocnienieREVERB1=0, wzmocnienieREVERB2=0,
 		wzmocnienieREVERB3=0, wzmocnienieREVERB4=0,
    delayrev3, delayrev4, delayREVc1, delayREVc2, lr1, lr2, lr3, lr4, lcr1, lcr2, 
		wzmocnienieDELAY2=1, temp1REV,
		temp2REV, temp3REV, temp4REV, wartoscREV1, wartoscREV2, wartoscREV3, i=0, p=0,
		wzmocnienieREVERBc1=1, wzmocnienieREVERBc2=1, 
		lh, drganiabypass, TEMPGAIN, TEMPGAIN2, TEMPGAIN3, TEMPGAIN4,
		TEMPGAIN5, TEMPGAIN6, temp11, temp22, tempzwarcieDAC;
volatile u16 buffor[11000];  //buffor maksymalne opoznienie 200ms
u8 flagawylaczefekt=0, zalDELAY1=0, zalaczREVERB1=0, opoznienierev1=20, 
    opoznienierev2=50, opoznienierev3=70,
    opoznienierev4=80, opoznienieREVc1=100, opoznienieREVc2=50,
    opoznieniemsDELAY=200, 
    wzmocnienieDAC=1,  
    flagamenu=1, menu=1, nastawamenu=0, zmiananastawy=1, zapis=1, wartoscimpulsator, flagaimpulsatora,
		flagazwarciaBYPASS=1;
u16 bufforREVERB[5020];  //maksymalne opoznienie 100ms
u16 bufforREVERB2[5020]; //maksymalne opoznienie 100ms
u16 s, tempwartoscADC2, elmdrganPUSH, elmdrganBUTTONB;


//Wartosci nastawione
u32 nastawy[18];

const u32 flashnastawy[18]={ /*zal Delay */ 0, /*zal delay wielokrotny*/ 0, /*opoznienie delay*/ 100, /*tlumienie delay*/ 6,
	              /*zal Reverb*/ 0, /*Opoznienie Reverb1*/ 40, /*opoznienie Reverb2*/ 65, /*opoznienie Reverb3*/ 74,
	              /*opoznienie Reverb 4*/ 92, /*opoznienie Calkowity reverb1*/ 51, /*opoznienie calkowity Reverb 73*/ 71,
								/* tlumienie Reverb1*/ 6, /*tlumienie Reverb2*/ 6, /*tlumienie Reverb3*/ 6, /*tlumienie Reverb4*/ 6,
								/*tlumienie calkowity reverb1*/ 6, /*tlumienie calkowity reverb2*/ 6, /*tluminie calkowite*/ 12};

//Tabela dla regulacji tlumienia o 1db
const uint32_t wzmocnienie[41]={10000 ,8912, 7943, 7079, 6309, 5623, 5011, 4466, 3981, 3548, 3162, 2818, 2511, 2238, 1995, 1778,
	1548, 1412, 1258, 1122, 1000, 891, 794, 707, 630, 562, 501, 446, 398, 354, 316, 281, 251, 223, 199, 177, 158, 141, 125, 
	112, 100
};

//******************************************************
//Definicje dla obslugi pamieci FLASH

uint32_t EraseCounter = 0x00, Address = 0x00;
uint32_t NbrOfPage = 0x00;
volatile FLASH_Status FLASHStatus=FLASH_COMPLETE;

#define OffsetNazwy 0xA000
#define BaseAdresFlash 0x08000000

#define BANK1_WRITE_START_ADDR  ((uint32_t)0x0800A000)
#define BANK1_WRITE_END_ADDR    ((uint32_t)0x0800A400)
#define FLASH_PAGE_SIZE         ((uint16_t)0x400)
//*******************************************************

/*============================================================
W przypadku wyrzucania bledu HardFault nalezy przejsc do mod_startup_stm32 i zadeklarowac wiekszy stos np 0x1000 oraz 
Heap size
===============================================================*/

int main(void)
{
 
  //konfiguracja peryferiow
  RCC_Config();   
  NVIC_Config();
  GPIO_Config(); 
	DMA_Config();
  ADC_Config();
	DAC_Config();
	
	
	
	//konfiguracja licznika SysTic 
	if (SysTick_Config_Mod(SysTick_CLKSource_HCLK_Div8, 195ul)) //przerwanie co 0,02ms
	{
		while(1);		// W razie bledu petla nieskonczona
	}			
	
	LCD_Initialize();  //Inicjalizacja wyswietlacza
	
	Flash_program();  //pierwsze wpisanie wartosci do pamieci FLASH
	
	Flash_odczyt();   //Odczytanie wartosci z flash 
		
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);  //rozpocznij przetwarzanie ADC
	
	//Wyczyszczenie erkanu lcd znakiem spacji
		LCD_WriteTextXY("                ", 0, 0);
    LCD_WriteTextXY("                ", 0, 1); //czyszczenie ekranu LCD16x2
	
		LCD_WriteTextXY("  DELAY REVERB  ", 0, 0);
	  LCD_WriteTextXY("  VOCAL EFFECT  ", 0, 1);
	
		delay(150000);  //odczekanie 3s
		
		//Wyczyszczenie erkanu lcd znakiem spacji
	 	LCD_WriteTextXY("                ", 0, 0);
		LCD_WriteTextXY("                ", 0, 1); //czyszczenie ekranu LCD16x2
		
		EXinterrrupt_Init(); //zalaczenie przerwan zewnetrznych
		

//==========================================================================================================
	
	//Petla glowna programu
  while (1) 	
	{		
		//sprawdzenie czy nie ustawilismy zbyt mocnego wzmocnienia dla mikrofonu dynamicznego
		//Sterowanie czerwona dioda gdy sygnal jest zbyt wysoki
	if(!timerdioda)
	{
		if(buforADC>4000) 
		{
			GPIO_WriteBit(GPIOC, GPIO_Pin_9, Bit_SET);
			timerdioda=2000;
		}
		else GPIO_WriteBit(GPIOC, GPIO_Pin_9, Bit_RESET);
		//Sterowanie zielona dioda gdy sygnal posiada dobrze dobrane wzmocnienie
		if(buforADC>3000 && (buforADC<4000))
		{
			GPIO_WriteBit(GPIOC, GPIO_Pin_8, Bit_SET);
			timerdioda=2000;
		} else GPIO_WriteBit(GPIOC, GPIO_Pin_8, Bit_RESET);
	}	
		

		
		if(Shannon==1) //zezwolenie na zmiane DAC po czasie zgodnym z twierdzeniem Shannona
		{
				
			Shannon=0;
			s=k;
			
			buffor[s]=(uint16_t)(buforADC+(zalDELAYwielokrotny*wartoscDELAY)); //jezeli jest zalaczony delay wielkorotny
						
			if(flagawylaczefekt) //jezeli wylaczyliscmy efekt to bezposrednie przekierowanie z ADC do DAC
			{
				
				if(flagazwarciaBYPASS) //warunek w ktorym nastepuje lagodne wylaczenie efektu przez BYPASS
				{
					timerzwarcieDAC=20000; //czas zwarcia DACA tzn jego ustawienie na skladowa stala
					tempzwarcieDAC=wartoscDAC; //przypisanie chwilowej wartosci do zmiennej chwilowej
					flagazwarciaBYPASS=0; //zakaz ponownego wejscia do efektu - wykasowanie flagi
				}
				wartoscDAC=buforADC;	
				
			}
			else                //jezeli jest zalaczony to do wartosc DAC bedziemy przkierowywac wartosci obliczone przez procesor
    	{
						flagazwarciaBYPASS=1;
				 //    wartoscDAC=buforADC + wartoscDELAY + zalaczREVERB1*(wartoscREV1);
				
					 wartoscDAC=buforADC + wartoscDELAY + zalaczREVERB1*(wartoscREV1+wartoscREV2+wartoscREV3);
				
			}
					
		
			//tutaj nastepuje zmiana wartosci DAC
			TEMPGAIN=wartoscDAC*wzmocnienie[wzmocnienieDAC];
			wartoscDAC=TEMPGAIN/10000;
			
			if(timerzwarcieDAC)
			{
				if(tempzwarcieDAC<wartoscDAC)
				{
					tempzwarcieDAC=tempzwarcieDAC+1;
					DAC_SetChannel1Data(DAC_Align_12b_R, tempzwarcieDAC); 
				}
				if(tempzwarcieDAC>wartoscDAC)
				{
					tempzwarcieDAC=tempzwarcieDAC-1;
					DAC_SetChannel1Data(DAC_Align_12b_R, tempzwarcieDAC); 
				}
			}
			else DAC_SetChannel1Data(DAC_Align_12b_R, wartoscDAC);
			
	
			
			
			}
			
		
	
		//===================================================================================
		//***********************************************************************************
		//Delay
		if(zalDELAY1)
		{
		delayms=50*opoznieniemsDELAY; //opoznienie w ms dla efektu DELAY
		if(s>=delayms) l=s-delayms; else l=11000-(delayms-s);
		wartoscDELAY=(buffor[l]);  //dzielimy poniewaz ucho slyszy logarytmicznie
		TEMPGAIN=wartoscDELAY*wzmocnienie[wzmocnienieDELAY2];
		wartoscDELAY=TEMPGAIN/10000;
		}
		
		//***********************************************************************************
		
		//Reverb1
		if(zalaczREVERB1)  //jezeli jest zalaczony efekt Reverb1 to wykonuj obliczenia sygnalu
		{
					delayrev1=50*opoznienierev1;
			    delayrev2=50*opoznienierev2;
			    delayrev3=50*opoznienierev3;
			    delayrev4=50*opoznienierev4;
			
					if(s>=delayrev1) lr1=s-delayrev1; else lr1=11000-(delayrev1-s);
		      if(s>=delayrev2) lr2=s-delayrev2; else lr2=11000-(delayrev2-s);
					if(s>=delayrev3) lr3=s-delayrev3; else lr3=11000-(delayrev3-s);
		      if(s>=delayrev4) lr4=s-delayrev4; else lr4=11000-(delayrev4-s);
			
				  temp1REV=buffor[lr1];
					TEMPGAIN=temp1REV*wzmocnienie[wzmocnienieREVERB1];
					temp1REV=TEMPGAIN/10000;	
					temp2REV=buffor[lr2];
					TEMPGAIN2=temp2REV*wzmocnienie[wzmocnienieREVERB2];
					temp2REV=TEMPGAIN2/10000;
			    temp3REV=buffor[lr3];
					TEMPGAIN3=temp3REV*wzmocnienie[wzmocnienieREVERB3];
					temp3REV=TEMPGAIN3/10000;
			    temp4REV=buffor[lr4];
					TEMPGAIN4=temp4REV*wzmocnienie[wzmocnienieREVERB4];
			    temp4REV=TEMPGAIN4/10000;
			
					wartoscREV1=temp1REV + temp2REV + temp3REV + temp4REV;
			
			//zezwolenie na wykonanie obliczen dla bufforow REVERB
				if(flagaREVERB)
				{
					flagaREVERB=0;
			    i++;
			    if(i>5019) i=0;
					bufforREVERB[i]=wartoscREV1 + wartoscREV3;
					
					delayREVc1=50*opoznienieREVc1; 
					delayREVc2=50*opoznienieREVc2;  
					
					if(i>=delayREVc1) lcr1=i-delayREVc1; else lcr1=5020-(delayREVc1-i);
					TEMPGAIN5=bufforREVERB[lcr1]*wzmocnienie[wzmocnienieREVERBc1];
					wartoscREV2=TEMPGAIN5/10000;	
					
					p++;
			    if(p>5019) p=0;
					bufforREVERB2[p]=wartoscREV2;
					if(p>=delayREVc2) lcr2=p-delayREVc2; else lcr2=5020-(delayREVc2-i);
					TEMPGAIN6=bufforREVERB2[lcr2]*wzmocnienie[wzmocnienieREVERBc2];
					wartoscREV3=TEMPGAIN6/10000;
				}
		
		
	}
			
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		//BYPASS - przycisk wylaczenia efektow
		
		if((!BYPASS) && (!drganiabypass))
		{
			drganiabypass=1000;
			if(flagawylaczefekt) 
				{
					//lagodne przejscie spowrotem do efektu przy wylaczaniu efektu
					timerzwarcieDAC=20000; //czas zwarcia DACA 
					tempzwarcieDAC=wartoscDAC; //przypisanie chwilowej wartosci do zmiennej chwilowej
					flagawylaczefekt=0; 
		   	}
			else flagawylaczefekt=1;
		} 
		else if(BYPASS && drganiabypass) drganiabypass--;
	
		//--------------------------------------------------------------------------------
		//obsluga menu dla wyswietlacza HD44780
		
		wartoscimpulsator=Impulsator(); //pobranie stanu z impulsatora
		
			//Zmiana wboru menu na impulsatorze
			if(nastawamenu==0)
			{
					if(wartoscimpulsator==2)
					{
						menu++;
						if(menu>18) menu=1;
						flagamenu=1;
					}
			if(wartoscimpulsator==1)
				{
				menu--;
				if(menu<1) menu=18;
				flagamenu=1;
				}
			}
			
			//Zmiana wyboru wartosci danego menu na impulsatorze
			if(nastawamenu==1)
			{
				
				if(wartoscimpulsator==2)
					{
						nastawy[(menu-1)]++;
						flagamenu=1;
						zmiananastawy=1;
					}
					
		  	if(wartoscimpulsator==1)
				  {
			    	nastawy[(menu-1)]--;
				    flagamenu=1;
						zmiananastawy=1;
				  }
					
				switch(menu)
				{
					case 1:
									{
										if(nastawy[(menu-1)]==2) nastawy[(menu-1)]=1;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=0;
										break;
									}
					case 2:
									{
										if(nastawy[(menu-1)]==2) nastawy[(menu-1)]=1;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=0;
										break;
									}
					case 3:
							   	{
										if(nastawy[(menu-1)]==201) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=200;
										break;
									}
					case 4:
							  	{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
					case 5:
									{
										if(nastawy[(menu-1)]==2) nastawy[(menu-1)]=1;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=0;
										break;
									}
					case 6:
									{
										if(nastawy[(menu-1)]==201) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=200;
										break;
									}
					case 7:
									{
										if(nastawy[(menu-1)]==201) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=200;
										break;
									}
					case 8:
									{
										if(nastawy[(menu-1)]==201) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=200;
										break;
									}
					case 9:
									{
										if(nastawy[(menu-1)]==201) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=200;
										break;
									}
					case 10:
									{
										if(nastawy[(menu-1)]==201) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=200;
										break;
									}
					case 11:
									{
										if(nastawy[(menu-1)]==201) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=200;
										break;
									}
					case 12:
									{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
					case 13:
									{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
					case 14:
									{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
					case 15:
									{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
					case 16:
									{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
					case 17:
									{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
	        case 18:
									{
										if(nastawy[(menu-1)]==41) nastawy[(menu-1)]=0;
										if(nastawy[(menu-1)]>250) nastawy[(menu-1)]=40;
										break;
									}
				}
					
			}
			
			//zmiana menu na impulsatorze badz nastawy
			if(!PUSH && !elmdrganPUSH)
			{
				elmdrganPUSH=700;
				flagaPUSH=1; //zezwolenie na inkrementacje licznika
				timerPUSH=0; //wykasowanie licznika
			
			}
			else if(PUSH && elmdrganPUSH) elmdrganPUSH--;
			else if(PUSH && !elmdrganPUSH && flagaPUSH)
			{
				flagaPUSH=0;
				if(timerPUSH<120000) 
				{
						if(nastawamenu)  //zmiana wyboru zmiana nastawy zmiana menu
						{
							nastawamenu=0;  
							LCD_WriteTextXY(" ", 4, 1); //wykasowanie informacji zmiany
						}
						else
						{						
							nastawamenu=1;
							LCD_WriteTextXY(">", 4, 1);
						}
				}
				//----------------------------------------------------------
				//Tutan nastepuje zapisanie wartosci do pamieci FLASH
				if(timerPUSH>=120000)
				{
					 
					Flash_zapis(); //zapisanie aktualnego stanu do pamieci flash
					
					timerZAPIS=120000; //zmienna czasu zezwalajaca na wyswietlenie informacji o zapisie
				}
			}
		
		//Narysowanie na wyswietlaczu wartosci poszczegolnych parametrow
		if(flagamenu)
		{
			flagamenu=0;
			
			switch(menu)
			{
				case 1:
				{
					LCD_WriteTextXY("  DELAY ZALACZ  ", 0, 0);  //nazwa podmenu
					LCD_value(nastawy[0], 3);										//wartosc dla danego podmenu
					break;
				}
				case 2:
				{
					LCD_WriteTextXY(" DELAY KROTNOSC ", 0, 0);
					LCD_value(nastawy[1], 3);
					break;
				}
				case 3:
				{
					LCD_WriteTextXY("OPOZNIENIE DELAY", 0, 0);
					LCD_value(nastawy[2], 2);
					break;
				}
				case 4:
				{
					LCD_WriteTextXY("TLUMIENIE DELAY ", 0, 0);
					LCD_value(nastawy[3], 1);
					break;
				}
				case 5:
				{
					LCD_WriteTextXY(" REVERB ZALACZ  ", 0, 0);
					LCD_value(nastawy[4], 3);
					break;
				}
				case 6:
				{
					LCD_WriteTextXY("OPOZNIENIE REV1 ", 0, 0);
					LCD_value(nastawy[5], 2);
					break;
				}
				case 7:
				{
					LCD_WriteTextXY("OPOZNIENIE REV2 ", 0, 0);
					LCD_value(nastawy[6], 2);
					break;
				}
				case 8:
				{
					LCD_WriteTextXY("OPOZNIENIE REV3 ", 0, 0);
					LCD_value(nastawy[7], 2);
					break;
				}
				case 9:
				{
					LCD_WriteTextXY("OPOZNIENIE REV4 ", 0, 0);
					LCD_value(nastawy[8], 2);
					break;
				}
				case 10:
				{
					LCD_WriteTextXY("OPOZNIENIE CREV1", 0, 0);
					LCD_value(nastawy[9], 2);
					break;
				}
				case 11:
				{
					LCD_WriteTextXY("OPOZNIENIE CREV2", 0, 0);
					LCD_value(nastawy[10], 2);
					break;
				}
				case 12:
				{
					LCD_WriteTextXY(" TLUMIENIE REV1 ", 0, 0);
					LCD_value(nastawy[11], 1);
					break;
				}
				case 13:
				{
					LCD_WriteTextXY(" TLUMIENIE REV2 ", 0, 0);
					LCD_value(nastawy[12], 1);
					break;
				}
				case 14:
				{
					LCD_WriteTextXY(" TLUMIENIE REV3 ", 0, 0);
					LCD_value(nastawy[13], 1);
					break;
				}
					case 15:
				{
					LCD_WriteTextXY(" TLUMIENIE REV4 ", 0, 0);
					LCD_value(nastawy[14], 1);
					break;
				}
					case 16:
				{
					LCD_WriteTextXY("TLUMIENIE CREV1 ", 0, 0);
					LCD_value(nastawy[15], 1);
					break;
				}
					case 17:
				{
					LCD_WriteTextXY("TLUMIENIE CREV2 ", 0, 0);
					LCD_value(nastawy[16], 1);
					break;
				}
					case 18:
				{
					LCD_WriteTextXY(" TLUMIENIE WYJ  ", 0, 0);
					LCD_value(nastawy[17], 1);
					break;
				}					
			}
			//Fragment odpowiedzialny za przepisanie wartosci z bufora nastawy do zmniennnych na ktorych operuje efekt
				if(zmiananastawy)
				{
					zmiananastawy=0;
					
					//Przepisanie wartosci
					zalDELAY1=nastawy[0];
					zalDELAYwielokrotny=nastawy[1];
					opoznieniemsDELAY=nastawy[2];
					wzmocnienieDELAY2=nastawy[3];
					zalaczREVERB1=nastawy[4];
					opoznienierev1=nastawy[5];
					opoznienierev2=nastawy[6];
					opoznienierev3=nastawy[7];
					opoznienierev4=nastawy[8];
					opoznienieREVc1=nastawy[9];
					opoznienieREVc2=nastawy[10];
					wzmocnienieREVERB1=nastawy[11];
					wzmocnienieREVERB2=nastawy[12];
					wzmocnienieREVERB3=nastawy[13];
					wzmocnienieREVERB4=nastawy[14];
					wzmocnienieREVERBc1=nastawy[15];
					wzmocnienieREVERBc2=nastawy[16];
					wzmocnienieDAC=nastawy[17];
				}
			
		}
		
		
		//Warunki wypisujace na wyswietlaczu napis S informujacy o zapisie
		if(timerZAPIS && zapis)
		{
			
			zapis=0;
			LCD_WriteTextXY("S", 0, 1);  //Napisanie s
			
		}
		else if(!timerZAPIS && !zapis)
		{
			
			zapis=1;
			LCD_WriteTextXY(" ", 0, 1); //Wyczyszczenie s
			
		}
	
		//*************************************************************************************	
	} //koniec petli nieskonczonej
}//koniec glownej funkcji programu

/****************************************************************************************
================================== CIALA FUNKCJI =========================================
*****************************************************************************************/


void RCC_Config(void)
{
  ErrorStatus HSEStartUpStatus;                          //zmienna opisujaca rezultat uruchomienia HSE

  RCC_DeInit();                                          //Reset ustawien RCC
  RCC_HSEConfig(RCC_HSE_ON);                             //Wlaczenie HSE
  HSEStartUpStatus = RCC_WaitForHSEStartUp();            //Odczekaj az HSE bedzie gotowy
  if(HSEStartUpStatus == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);//
    FLASH_SetLatency(FLASH_Latency_2);                   //ustaw zwloke dla pamieci Flash; zaleznie od taktowania rdzenia
                                                         //0:<24MHz; 1:24~48MHz; 2:>48MHz

		RCC_HCLKConfig(RCC_SYSCLK_Div1);                     //ustaw HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);                      //ustaw PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);                      //ustaw PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_PREDIV1, RCC_PLLMul_9); //ustaw PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz
		
	  RCC_ADCCLKConfig(RCC_PCLK2_Div6); 
		
    RCC_PLLCmd(ENABLE);                                  //wlacz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);  //odczekaj na poprawne uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           //ustaw PLL jako zrodlo sygnalu zegarowego
    while(RCC_GetSYSCLKSource() != 0x08);                //odczekaj az PLL bedzie sygnalem zegarowym systemu
  
  /*kod zwiazany z konfiguracja sygnalow zegarowych potrzebnych w programie peryferiow*/
  
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
		
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE); //wlaczenie wyjsc alternatywnych
		
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE); 
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);  
		
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE);  //zalaczenie przetwornika DAC
	
	
  } else {
  } 
}

void NVIC_Config(void)
{
	
NVIC_InitTypeDef NVIC_InitStructure;
	
//Konfigurowanie kontrolera przerwan NVIC
#ifdef  VECT_TAB_RAM  
  // Jezeli tablica wektorow w RAM, to ustaw jej adres na 0x20000000
  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
#else  // VECT_TAB_FLASH
  // W przeciwnym wypadku ustaw na 0x08000000
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
#endif
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0); 
	
	  NVIC_InitStructure.NVIC_IRQChannel =EXTI4_IRQn ; //tutaj trzeba zwrocic uwage na definicje w pliu stm32f10x.h
	//******************************************************************************************************************
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);
	
}

void GPIO_Config(void)
{

  //konfigurowanie portow GPIO
  GPIO_InitTypeDef  GPIO_InitStructure; 
	
	//konfiguracja wyjsc analogowych
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_1;   
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;                                   //wejscia analogowe
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_5;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_9 | GPIO_Pin_8;   
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;                                   
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOC, &GPIO_InitStructure);
	
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_8;   									//przycisk BYPASS
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;                                   
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

	//obsluga impulsatora
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
		
}

//funkcja opozniajaca
void delay(uint32_t us)
{
TIMERUS=us;	
	while(TIMERUS);
}

void DMA_Config(void)
{
  #define ADC1_DR_Address 0x4001244C;                                             //adres rejestru ADC1->DR
 
	
  DMA_InitTypeDef DMA_InitStructure;

  DMA_DeInit(DMA1_Channel1);                                                      //Usun ewentualna poprzednia konfiguracje DMA
   
	
  DMA_InitStructure.DMA_PeripheralBaseAddr = (unsigned long int)ADC1_DR_Address;  //Adres docelowy transferu
  DMA_InitStructure.DMA_MemoryBaseAddr = (unsigned long int)&buforADC;            //Adres poczatku bloku do przeslania
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;                              //Kierunek transferu
  DMA_InitStructure.DMA_BufferSize = 1;                                           //Liczba elementow do przeslania (dlugosc bufora)
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;                //Wylaczenie automatycznego zwiekszania adresu po stronie ADC
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;                         //Wlaczenie automatycznego zwiekszania adresu po stronie pamieci (bufora)
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;     //Rozmiar pojedynczych przesylanych danych po stronie ADC (HalfWord = 16bit)
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;             //Rozmiar pojedynczych przesylanych danych po stronie pamieci (bufora)
  DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;                                 //Tryb dzialania kontrolera DMA - powtarzanie cykliczne
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;                             //Priorytet DMA - wysoki
  DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;                                    //Wylaczenie obslugi transferu z pamieci do pamieci
  DMA_Init(DMA1_Channel1, &DMA_InitStructure);                                    //Zapis konfiguracji

  //Wlacz DMA, kanal 1
  DMA_Cmd(DMA1_Channel1, ENABLE);  
	
}

void ADC_Config(void)
{
  ADC_InitTypeDef ADC_InitStructure;
	  
	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;                  //Jeden przetwornik, praca niezalezna
	ADC_InitStructure.ADC_ScanConvMode = DISABLE;                       // konieczne skanowanie kanalow 
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;                  //Pomiar w trybie ciaglym
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;	//Brak wyzwalania zewnetrznego
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;            	//Wyrownanie danych do prawej - 12 mlodszych bitow znaczacych
	ADC_InitStructure.ADC_NbrOfChannel = 1; 	                          //Liczba uzywanych kanalow =3
	ADC_Init(ADC1, &ADC_InitStructure);                                 //Incjalizacja przetwornika

	  ADC_RegularChannelConfig(ADC1, ADC_Channel_1, 1, ADC_SampleTime_1Cycles5); 

                                                                      //Kanal 1 - GPIOA1 
                                                                      //Grupa podstawowa, czas probkowania 1,5+12,5=14 cykli = 1us (calkowity czas przetwarania)
  ADC_DMACmd(ADC1,ENABLE);                                            //Wlaczenie DMA dla ADC  
  ADC_Cmd(ADC1, ENABLE);	                                            //Wlacz ADC1
	ADC_ResetCalibration(ADC1);	                                        //Reset rejestrow kalibracyjnych ADC1
	while(ADC_GetResetCalibrationStatus(ADC1));	                        //Odczekanie na wykonanie resetu
	ADC_StartCalibration(ADC1);	                                        //Kalibracja ADC1
	while(ADC_GetCalibrationStatus(ADC1));    	                        //Odczekanie na zakonczenie kalibracji ADC1
	
}

void DAC_Config(void)
{

	DAC_InitTypeDef   DAC_InitStructure;
	
	DAC_DeInit();

  DAC_InitStructure.DAC_Trigger = DAC_Trigger_None;										//Wyzwalanie ciagle
  DAC_InitStructure.DAC_WaveGeneration = DAC_WaveGeneration_None;			//Wylaczenie generacji fsli
  DAC_InitStructure.DAC_OutputBuffer = DAC_OutputBuffer_Enable;				//Zalaczenie buffora wyjsciowego
	
  DAC_Init(DAC_Channel_1, &DAC_InitStructure);												//inicjalizacja

	DAC_Cmd(DAC_Channel_1, ENABLE);																			//zalaczenie
	
}

//Funkcja sluzaca do obslugi impulsatora
uint8_t Impulsator(void)
{	
	uint8_t leftright;
	
 
	 if(!BUTTONA && !elmdrganBUTTONA)
	 {
		 elmdrganBUTTONA=1;
		 if(kierunekimp==1) leftright=1;
		 if(kierunekimp==2) leftright=2;
		 
	 }
	 else if(BUTTONA && elmdrganBUTTONA)
	 { 
		 elmdrganBUTTONA--;	 
		 leftright=0;
	 }
   else leftright=0;
	
	return leftright;
	
 
}

// Wartosc wyswietlana na wyswietlaczu lcd
//jednostka =1 wtedy db, =2 wtedy ms =3 tak nie
//value przy jednostce =3 value=0 nie value=1 tak
void LCD_value(uint16_t value, uint8_t jednostka)
{
	 uint8_t setne, dziesietne, jednosci;
	 char bufforvalue[7];
	
	if(jednostka !=3)
	{
	 setne=value/100;
	 dziesietne=value-(setne*100);
	 dziesietne=dziesietne/10;
	 jednosci=value-(setne*100)-(dziesietne*10);
		
	 if(setne) bufforvalue[0]=0x30+setne; else bufforvalue[0]=0x20;
	 if(!setne && !dziesietne) bufforvalue[1]=0x20; else bufforvalue[1]=0x30+dziesietne;
	 bufforvalue[2]=0x30+jednosci;
	 bufforvalue[3]=0x20;
		if(jednostka==1)  //napis db
		{
			bufforvalue[4]=0x64;
			bufforvalue[5]=0x42;
			bufforvalue[6]=0x00; //znak null konczacy napis
		}
		else if(jednostka==2) //napis ms
		{
			bufforvalue[4]=0x6d;
			bufforvalue[5]=0x73;
			bufforvalue[6]=0x00; //znak null konczacy napis
		}
	}
	else
	{
		if(value==0)  //Napis nie
		{
			bufforvalue[0]=0x20;
			bufforvalue[1]=0x4E;
			bufforvalue[2]=0x49;
			bufforvalue[3]=0x45;
			bufforvalue[4]=0x20;
			bufforvalue[5]=0x20;
			bufforvalue[6]=0x00;
		}
		else  //Napis tak
		{
			bufforvalue[0]=0x20;
			bufforvalue[1]=0x54;
			bufforvalue[2]=0x41;
			bufforvalue[3]=0x4B;
			bufforvalue[4]=0x20;
			bufforvalue[5]=0x20;
			bufforvalue[6]=0x00;
		}
	}
	
	 LCD_WriteTextXY(bufforvalue, 5, 1);
	
}

//Wpisanie do pamieci FLASH wartosci
void Flash_program(void)
{
	
	 u8   i;
  volatile u32  j;
	u32 *k;
	
	k=(u32 *)(BaseAdresFlash + OffsetNazwy);  //ustawienie wskaznika na adres komorki ktora jest flaga czy juz byl dokonany zapis i pierwsze uruchonmienie
	
	if(*k!=0x234fab23) //sprawdzenie po zalaczeniu czy pamiec juz byla uzywana i nie jest to pierwszy raz po zapisie 
	{
	
	//Odblokowanie flash
	
	FLASH_Unlock(); 
	
	NbrOfPage = (BANK1_WRITE_END_ADDR - BANK1_WRITE_START_ADDR) / FLASH_PAGE_SIZE;
	
	FLASH_ClearFlag(FLASH_FLAG_EOP|FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR);
	

  // Wykasowanie pamieci 
  for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (FLASHStatus == FLASH_COMPLETE); EraseCounter++)
  {
    FLASHStatus = FLASH_ErasePage(BANK1_WRITE_START_ADDR + (FLASH_PAGE_SIZE * EraseCounter));
  }
	
		FLASH_ProgramWord(BaseAdresFlash + OffsetNazwy, 0x234fab23); //wpisanie wartosci flagi aby przy ponownym uruchamianiu oszczedzac pamiec flash
	
		j=(BaseAdresFlash+OffsetNazwy+4);
	
		for(i=0; i<18; i++)
		{
			
			 while(FLASH_COMPLETE!=FLASH_ProgramWord(j, flashnastawy[i]))
			 {
			 }
				j=j+4;
			 	
	}	
		
	FLASH_Lock();  //zablokowanie dostepu do pamieci flash
	
	}
}

//Odczyt nastawionych parametrow z pamieci flash
void Flash_odczyt(void)
{
	u32 *p;
	u8  t;
	
	p=(u32 *)(BaseAdresFlash+OffsetNazwy+4);
	
	for(t=0; t<18; t++)
	{		
		nastawy[t]=*p; //przepisanie wartosci z flash
	  p=p+1;         //inkrementacja adresu o 4bajty gdyz mamy zmienna 4bajtowa-32bity	
	}
	
}

void Flash_zapis(void)
{
	 u8   i;
  volatile u32  j;
	
	
		//Odblokowanie flash
	
	FLASH_Unlock(); 
	
	NbrOfPage = (BANK1_WRITE_END_ADDR - BANK1_WRITE_START_ADDR) / FLASH_PAGE_SIZE;
	
	FLASH_ClearFlag(FLASH_FLAG_EOP|FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR);
	

  // Wykasowanie pamieci 
  for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (FLASHStatus == FLASH_COMPLETE); EraseCounter++)
  {
    FLASHStatus = FLASH_ErasePage(BANK1_WRITE_START_ADDR + (FLASH_PAGE_SIZE * EraseCounter));
  }
	
		FLASH_ProgramWord(BaseAdresFlash + OffsetNazwy, 0x234fab23);  //zmienna blokujaca nadpisanie przy uruchomieniu
	
	
		j=(BaseAdresFlash+OffsetNazwy+4);
	
		for(i=0; i<18; i++)
		{
			
			 while(FLASH_COMPLETE!=FLASH_ProgramWord(j, nastawy[i]))
			 {
			 }
				j=j+4;
			 	
	}	
		
	FLASH_Lock();  //zablokowanie dostepu do pamieci flash
}

void EXinterrrupt_Init(void)
{
    EXTI_InitTypeDef EXTI_InitStructure;

  
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOB, GPIO_PinSource4);    //Ustawienie zrodla przerwania

  //Konfiguracja przerwania EXTI0 na linie PB4
	EXTI_ClearITPendingBit(EXTI_Line4);
  EXTI_InitStructure.EXTI_Line = EXTI_Line4;                     //Wybor linii 
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;            //Ustawienie generowania przerwania (a nie zdarzenia)
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;        //Wyzwalanie zboczem opadajacym (wcisniecie przycisku)
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;                      //Wlaczenie przerwania
  EXTI_Init(&EXTI_InitStructure);
   
}
